ALTER TABLE `UserWarnings`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserWarnings`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserWarningsHistory`
(
    `Id`          BIGINT(20)   NOT NULL,
    `Description` VARCHAR(255) NOT NULL,
    `UserId`      BIGINT(20)   NOT NULL,
    `Author`      BIGINT(20) DEFAULT NULL,
    `Deleted`     BOOL       DEFAULT FALSE,
    `DateFrom`    DATETIME(6)  NOT NULL,
    `DateTo`      DATETIME(6)  NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserWarningsUpdate`;

CREATE TRIGGER `TR_UserWarningsUpdate`
    AFTER UPDATE
    ON `UserWarnings`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserWarningsHistory` (
        `Id`, `Description`, `UserId`, `Author`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Description, OLD.UserId, OLD.Author, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserWarningsDelete`;

CREATE TRIGGER `TR_UserWarningsDelete`
    AFTER DELETE
    ON `UserWarnings`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserWarningsHistory` (
        `Id`, `Description`, `UserId`, `Author`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Description, OLD.UserId, OLD.Author, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;