from cpl_core.logging import LoggerABC
from cpl_discord.command import DiscordCommandABC
from cpl_discord.service import DiscordBotServiceABC
from discord.ext import commands
from discord.ext.commands import Context

from bot_core.helper.command_checks import CommandChecks
from modules.base.forms.complaint_form import ComplaintForm


class ComplaintCommand(DiscordCommandABC):
    def __init__(self, logger: LoggerABC, bot: DiscordBotServiceABC, form: ComplaintForm):
        DiscordCommandABC.__init__(self)

        self._logger = logger
        self._bot = bot
        self._form = form

    @commands.hybrid_command()
    @commands.guild_only()
    @CommandChecks.check_is_ready()
    async def complaint(self, ctx: Context):
        self._logger.debug(__name__, f"Received command complaint {ctx}")
        await ctx.interaction.response.send_modal(self._form)
        self._logger.trace(__name__, f"Finished command complaint {ctx}")
